<!-- Row -->
<div class="row">
    <!-- Column -->
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <div class="row">
                    <div class="col-12">
                        <div class="card">
                            <div class="card-body no-padding-left no-padding-right">
                                <div class="row">
                                    <div class="col-12">
                                        <div class="form-group">
                                            <label>Arquivo </label>
                                            <input class="form-control" disabled
                                                   value="{{ customerFile.file_name }}.{{ customerFile.file_extension }}"/>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-3">
                                        <div class="form-group">
                                            <label>Linhas</label>
                                            <input disabled
                                                   value="{{ data.length }}"
                                                   class="form-control"/>
                                        </div>
                                    </div>
                                    <div class="col-3">
                                        <div class="form-group">
                                            <label>Linhas filtradas</label>
                                            <input disabled
                                                   value="{{ (data | filterDataBy: columns: filters).length }}"
                                                   class="form-control"/>
                                        </div>
                                    </div>
                                    <div class="col-2">
                                        <div class="form-group">
                                            <button (click)="persistData()" class="btn btn-block btn-dark-success">
                                                <i class="fa fa-save"></i>
                                                Salvar mudanças
                                            </button>
                                        </div>
                                    </div>
                                    <div class="col-2">
                                        <div class="form-group">
                                            <button (click)="refreshData()" class="btn btn-block btn-primary">
                                                <i class="fa fa-sync"></i>
                                                Resetar dados
                                            </button>
                                        </div>
                                    </div>

                                    <div class="col-2">
                                        <div class="form-group">
                                            <button (click)="goBack()" class="btn btn-block btn-info">
                                                <i class="fa fa-history"></i>
                                                Voltar
                                            </button>
                                        </div>
                                    </div>
                                </div>
                                <table id="table-data" class="table table-responsive table-striped table-bordered">
                                    <thead>
                                    <tr>
                                        <th>
                                            <div class="btn-group btn-table-group">
                                                <button class="btn btn-sm btn-primary btn-rounded"
                                                        (click)="showFilter = !showFilter"
                                                        tooltip="Exibir filtros"
                                                        placement="bottom">
                                                    <i class="fa fa-filter"></i>
                                                </button>
                                                <button *ngIf="!fullButtonMode"
                                                        class="btn btn-sm btn-success btn-rounded"
                                                        (click)="fullButtonMode = true"
                                                        tooltip="Exibir todos os botões"
                                                        placement="bottom">
                                                    <i class="fa fa-expand"></i>
                                                </button>
                                                <button *ngIf="fullButtonMode"
                                                        class="btn btn-sm btn-success btn-rounded"
                                                        (click)="fullButtonMode = false"
                                                        tooltip="Exibir botões reduzidos"
                                                        placement="bottom">
                                                    <i class="fa fa-compress"></i>
                                                </button>
                                            </div>
                                        </th>
                                        <th *ngFor="let column of columns; let j = index">
                                            <div class="row">
                                                <div class="col-12 column-title">
                                                    {{ column }}

                                                    <div class="btn-group" dropdown *ngIf="!fullButtonMode">
                                                        <div class="btn-group" dropdown *ngIf="!fullButtonMode">
                                                            <button class="btn btn-sm " dropdownToggle
                                                                    aria-controls="dropdown-basic">
                                                                <i class="fa fa-ellipsis-v"></i>
                                                            </button>

                                                            <ul id="dropdown-basic2" *dropdownMenu class="dropdown-menu"
                                                                role="menu" aria-labelledby="button-basic">
                                                                <li role="menuitem">
                                                                    <a class="dropdown-item text-danger"
                                                                       href="javascript:void(0)"
                                                                       (click)="removeColumn(j)"><i
                                                                            class="fa fa-trash"></i>
                                                                        Excluir coluna</a>
                                                                </li>

                                                                <li class="divider dropdown-divider"></li>

                                                                <li role="menuitem">
                                                                    <a class="dropdown-item text-primary"
                                                                       href="javascript:void(0)"
                                                                       (click)="moveColumnLeft(j)">
                                                                        <i class="fa fa-arrow-left"></i>
                                                                        Mover coluna para a esquerda
                                                                    </a>
                                                                </li>
                                                                <li role="menuitem">
                                                                    <a class="dropdown-item text-primary"
                                                                       href="javascript:void(0)"
                                                                       (click)="moveColumnRight(j)">
                                                                        <i class="fa fa-arrow-right"></i>
                                                                        Mover coluna para a direita</a>
                                                                </li>

                                                                <li class="divider dropdown-divider"></li>

                                                                <li role="menuitem">
                                                                    <a class="dropdown-item" href="javascript:void(0)"
                                                                       (click)="addColumnLeft(j)">
                                                                        <i class="fa fa-arrow-left"></i>
                                                                        <i class="fa fa-plus"></i>
                                                                        Adicionar coluna à esquerda</a>
                                                                </li>
                                                                <li role="menuitem">
                                                                    <a class="dropdown-item" href="javascript:void(0)"
                                                                       (click)="addColumnRight(j)">
                                                                        <i class="fa fa-arrow-right"></i>
                                                                        <i class="fa fa-plus"></i>
                                                                        Adicionar coluna à direita
                                                                    </a>
                                                                </li>
                                                            </ul>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="row">
                                                <div class="col-12">
                                                    <div class="btn-group btn-table-group" *ngIf="fullButtonMode">
                                                        <button (click)="removeColumn(j)"
                                                                class="btn btn-sm btn-danger btn-rounded"
                                                                tooltip="Excluir coluna"
                                                                placement="bottom">
                                                            <i class="fa fa-trash"></i>
                                                        </button>
                                                        <button class="btn btn-sm btn-rounded btn-primary"
                                                                (click)="moveColumnLeft(j)"
                                                                tooltip="Mover coluna para a esquerda"
                                                                placement="bottom">
                                                            <i class="fa fa-arrow-left"></i>
                                                        </button>
                                                        <button class="btn btn-sm btn-rounded btn-primary"
                                                                (click)="moveColumnRight(j)"
                                                                tooltip="Mover coluna para a direita"
                                                                placement="bottom">
                                                            <i class="fa fa-arrow-right"></i>
                                                        </button>
                                                        <button class="btn btn-sm btn-light-warning btn-rounded btn-add-col"
                                                                (click)="addColumnLeft(j)"
                                                                tooltip="Adicionar coluna à esquerda"
                                                                placement="bottom">
                                                            <i class="fa fa-arrow-left"></i>
                                                            <i class="fa fa-plus"></i>
                                                        </button>
                                                        <button class="btn btn-sm btn-light-warning btn-rounded btn-add-col"
                                                                (click)="addColumnRight(j)"
                                                                tooltip="Adicionar coluna à direita"
                                                                placement="bottom">
                                                            <i class="fa fa-plus"></i>
                                                            <i class="fa fa-arrow-right"></i>
                                                        </button>
                                                    </div>
                                                </div>
                                            </div>
                                        </th>
                                    </tr>
                                    <tr *ngIf="showFilter">
                                        <th></th>
                                        <th *ngFor="let column of columns; let i = index">
                                            <input [(ngModel)]="filters[column]"
                                                   class="form-control"
                                                   placeholder="Filtrar por {{ column }}..."/>
                                        </th>
                                    </tr>
                                    </thead>
                                    <tbody>

                                    <tr *ngFor="let item of data | filterDataBy: columns: filters; let i = index">
                                        <td>
                                            <div class="btn-group btn-table-group" *ngIf="fullButtonMode">
                                                <button (click)="removeLine(item.index)"
                                                        class="btn btn-dark-danger btn-sm btn-rounded"
                                                        tooltip="Remover linha">
                                                    <i class="fa fa-trash"></i>
                                                </button>
                                                <button *ngIf="!item.is_editing"
                                                        (click)="item.is_editing = true"
                                                        class="btn btn-primary btn-sm btn-rounded"
                                                        tooltip="Editar linha">
                                                    <i class="fa fa-edit"></i>
                                                </button>
                                                <button *ngIf="item.is_editing"
                                                        (click)="item.is_editing = false"
                                                        class="btn btn-success btn-sm btn-rounded"
                                                        tooltip="Finalizar edição">
                                                    <i class="fa fa-check"></i>
                                                </button>
                                                <button (click)="moveRowUp(i)"
                                                        class="btn btn-dark-info btn-sm btn-rounded"
                                                        tooltip="Mover linha acima">
                                                    <i class="fa fa-arrow-up"></i>
                                                </button>
                                                <button (click)="moveRowDown(i)"
                                                        class="btn btn-dark-info btn-sm btn-rounded"
                                                        tooltip="Mover linha abaixo">
                                                    <i class="fa fa-arrow-down"></i>
                                                </button>
                                                <button (click)="addRowBefore(i)"
                                                        class="btn btn-light-warning btn-sm btn-rounded btn-add-row"
                                                        tooltip="Inserir nova linha acima">
                                                    <i class="fa fa-plus"></i>
                                                    <i class="fa-1x fa fa-sort-up"></i>
                                                </button>
                                                <button (click)="addRowAfter(i)"
                                                        class="btn btn-light-warning btn-sm btn-rounded btn-add-row"
                                                        tooltip="Inserir nova linha abaixo">
                                                    <i class="fa fa-plus"></i>
                                                    <i class="fa-1x fa fa-sort-down"></i>
                                                </button>
                                            </div>
                                            <div class="btn-group" dropdown *ngIf="!fullButtonMode">
                                                <button class="btn btn-sm " dropdownToggle
                                                        aria-controls="dropdown-basic">
                                                    <i class="fa fa-ellipsis-v"></i>
                                                </button>

                                                <ul id="dropdown-basic" *dropdownMenu class="dropdown-menu"
                                                    role="menu" aria-labelledby="button-basic">
                                                    <li role="menuitem">
                                                        <a class="dropdown-item text-danger" href="javascript:void(0)"
                                                           (click)="removeLine(item.index)"><i class="fa fa-trash"></i>
                                                            Remover linha</a>
                                                    </li>

                                                    <li role="menuitem" *ngIf="!item.is_editing">
                                                        <a class="dropdown-item text-info" href="javascript:void(0)"
                                                           (click)="item.is_editing = true">
                                                            <i class="fa fa-edit"></i>
                                                            Editar linha</a>
                                                    </li>

                                                    <li role="menuitem" *ngIf="item.is_editing">
                                                        <a class="dropdown-item text-success" href="javascript:void(0)"
                                                           (click)="item.is_editing = false">
                                                            <i class="fa fa-check"></i>
                                                            Finalizar edição</a>
                                                    </li>

                                                    <li class="divider dropdown-divider"></li>

                                                    <li role="menuitem">
                                                        <a class="dropdown-item text-primary" href="javascript:void(0)"
                                                           (click)="moveRowUp(i)">
                                                            <i class="fa fa-arrow-up"></i>
                                                            Mover linha acima</a>
                                                    </li>
                                                    <li role="menuitem">
                                                        <a class="dropdown-item text-primary" href="javascript:void(0)"
                                                           (click)="moveRowDown(i)">
                                                            <i class="fa fa-arrow-down"></i>
                                                            Mover linha abaixo</a>
                                                    </li>

                                                    <li class="divider dropdown-divider"></li>

                                                    <li role="menuitem">
                                                        <a class="dropdown-item" href="javascript:void(0)"
                                                           (click)="addRowBefore(i)">
                                                            <i class="fa fa-plus"></i>
                                                            <i class="fa-1x fa fa-sort-up"></i>
                                                            Adicionar nova linha acima</a>
                                                    </li>
                                                    <li role="menuitem">
                                                        <a class="dropdown-item" href="javascript:void(0)"
                                                           (click)="addRowAfter(i)">
                                                            <i class="fa fa-plus"></i>
                                                            <i class="fa-1x fa fa-sort-down"></i>
                                                            Adicionar nova linha abaixo</a>
                                                    </li>
                                                </ul>
                                            </div>
                                        </td>
                                        <td *ngFor="let attribute of columns">
                                            <label *ngIf="!item['is_editing']">{{ item[attribute] }}</label>
                                            <input *ngIf="item['is_editing']"
                                                   class="form-control"
                                                   type="text"
                                                   [(ngModel)]="item[attribute]"/>
                                        </td>
                                    </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
